package com.inoct.NoctuAuthenticator.dto;


import java.util.List;

import com.inoct.NoctuAuthenticator.validation.ValidateUser;

import jakarta.validation.constraints.NotNull;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
@ValidateUser
public class UserDTO {
    private Long id;

    @NotNull
    private String username;

    @NotNull
    private String firstName;

    @NotNull
    private String lastName;

    private String email;

    private List<String> roles;

    private String password;

    @NotNull
    private boolean oauth;

    private OauthDataDTO oauthData;

}
