package com.inoct.NoctuAuthenticator.entity;

import java.time.LocalDateTime;
import java.util.UUID;

import org.hibernate.annotations.UpdateTimestamp;
import org.springframework.data.annotation.CreatedDate;

import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Entity
@AllArgsConstructor
@NoArgsConstructor
@Getter
@Setter
@EqualsAndHashCode(onlyExplicitlyIncluded = true)
@Builder
public class OauthData {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @EqualsAndHashCode.Include
    private Long id;

    @EqualsAndHashCode.Include
    @Transient
    private final UUID tempId = UUID.randomUUID();

    @OneToOne(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    @JoinColumn(name = "user_id")
    @NotNull
    private User user;

    @NotNull
    private String provider;

    @NotNull
    private String providerUserId;

    @NotNull
    private String accessToken;

    @NotNull
    private String refreshToken;

    LocalDateTime expiresAt;

    @NotNull
    private String [] scopes;

    @CreatedDate
    @Column(updatable = false)
    LocalDateTime createdDateTime;

    @UpdateTimestamp
    LocalDateTime updateTimestamp;

}
